#include <bits/stdc++.h>

typedef unsigned long ulong;

using namespace std;
map<ulong, vector<ulong>> numpad = {
    {0, {4, 2}},
    {9, {3, 3}},
    {8, {3, 2}},
    {7, {3, 1}},
    {6, {2, 3}},
    {5, {2, 2}},
    {4, {2, 1}},
    {3, {1, 3}},
    {2, {1, 2}},
    {1, {1, 1}},
};
struct Key{
    ulong r, c;
};

ulong dist(Key K1, Key K2){
    return abs((long long)K1.r - (long long)K2.r)+abs((long long)K1.c - (long long)K2.c);
}

Key toKey(ulong num, bool first){
    Key out;
    out.r = numpad[first ? num/10 : num%10][0];
    out.c = numpad[first ? num/10 : num%10][1];
    return out;
}

ulong hardClock(ulong hours, ulong minutes){
    Key H1 = toKey(hours, true), H2 = toKey(hours, false), M1 = toKey(minutes, true), M2 = toKey(minutes, false);
    return dist(H1, H2) + dist(H2, M1) + dist(M1, M2);
}
int main(){
    ulong HH, MM;
    string alarm, HH_str, MM_str;
    cin >> alarm;
    bool mode = true;
    for (ulong i = 0;i<alarm.length();i++){
        if (mode){
            if (alarm[i] == ':'){
                mode = false;
                continue;
            }
            HH_str.push_back(alarm[i]);
        } else {
            MM_str.push_back(alarm[i]);
        }
    }
    HH = (HH_str[0]-'0')*10 + HH_str[1]-'0';
    MM = (MM_str[0]-'0')*10 + MM_str[1]-'0';


    map<ulong, vector<ulong>> possable;
    ulong minn =99;
    while (1){
        vector<ulong> current = {HH, MM};
        ulong dd = hardClock(HH, MM);
        if (possable.find(dd) == possable.end()){
            possable[dd] = current;
        }
        if (dd < minn) minn = dd;
        if (MM+60 < 99){
            current[1] += 60;
            dd = hardClock(HH, MM+60);
            if (possable.find(dd) == possable.end()){
                possable[dd] = current;
            }
            if (dd < minn) minn = dd;
        }
        if (HH+24 > 99){
            break;
        }
        HH += 24;
    }
    cout << possable[minn][0] << ":" << possable[minn][1];
    return 0;
}
