#include <iostream>
#include <string>
#include <cmath>
using namespace std;
void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
}
pair<int, int> findcoords(int a) {
    switch(a) {
        case 1:
            return {1, 1};
        case 2:
            return {2, 1};
        case 3:
            return {3, 1};
        case 4:
            return {1, 2};
        case 5:
            return {2, 2};
        case 6:
            return {3, 2};
        case 7:
            return {1, 3};
        case 8:
            return {2, 3};
        case 9:
            return {3, 3};
        case 0:
            return {2, 4};
        //default:
            //cerr << "Findcoords!" << endl;
    }
}
int __dist(int a, int b) {
    pair<int, int> coordsA=findcoords(a);
    pair<int, int> coordsB=findcoords(b);
    return abs(coordsA.first-coordsB.first) + abs(coordsA.second-coordsB.second);
}
string conv(int a) {
    return to_string(a);
    //if(a<10) return (string)("0" + (char)(a+'0'));
    //return (string)("" + (char)((a/10)+'0') + (char)((a%10)+'0'));
}
int dist(int h, int m) {
    //cout << "dist " << h << " " << m << endl;
    string H=conv(h), M=conv(m);
    if(H.size()==1) H='0'+H;
    if(M.size()==1) M='0'+M;
    //cout << "dist " << H << " " << M << endl;
    return __dist(H[0]-'0', H[1]-'0')+__dist(H[1]-'0', M[0]-'0')+__dist(M[0]-'0', M[1]-'0');
}
int main() {
    fastIO();
    int a,b;
    char _;
    cin >> a >> _ >> b;
    int minDist=1000000000;
    int minh, minm;
    for(int h = a; h <= 99; h+=24) {
        for(int m = b; m <= 99; m += 60) {
            int q = dist(h, m);
            if(q<minDist) {
                minDist=q;
                minh=q;
                minm=q;
            }
        }
    }
    cout << (minh<10?"0":"") << minh << ":" << (minm<10?"0":"") << minm;
}
